<script setup lang="ts">
import type { MenuOption } from 'naive-ui'
import { breakpoints } from '~/configs'

const props = defineProps<{
  menuItems: MenuOption[]
  menuValue?: string
}>()

const emit = defineEmits<{
  (event: 'update:menuValue', value: string): void
}>()

const $state = useLocalStorage('\0LAYOUT_STATE', {
  sidebar: {
    collapsed: false,
  },
}, {
  mergeDefaults: true,
})

const sidebarHeaderRef = ref<HTMLDivElement>()
const { height: sidebarContentTop } = useElementBounding(sidebarHeaderRef)

const contentHeaderRef = ref<HTMLDivElement>()
const { height: contentTop } = useElementBounding(contentHeaderRef)

const appConfig = useAppConfig()
const route = useRoute()

const { sm } = useBreakpoints(breakpoints)
const shadowOffset = computed(() => sm.value ? 0 : 2)

const mobileCollapsed = ref(true)

const sidebar = reactive({
  enabled: true,
  collapsed: computed({
    get: () => sm.value
      ? $state.value.sidebar.collapsed
      : mobileCollapsed.value,
    set: (value) => {
      if (sm.value)
        $state.value.sidebar.collapsed = value
      else
        mobileCollapsed.value = value
    },
  }),
  width: computed(() => (sm.value ? 250 : '100%')),
  widthCollapsed: computed(() => (sm.value ? 64 : 0)),
  triggerVisible: computed(() => sm.value ? 'bar' : undefined),
})

const menu = reactive({
  current: computed(() => props.menuValue || route.path),
  options: computed(() => props.menuItems),
  iconSize: 24,
  accordion: true,
})

function handleMenuClick(key: string) {
  emit('update:menuValue', key)

  if (!sm.value && !sidebar.collapsed)
    sidebar.collapsed = true
}
</script>

<template>
  <NLayout position="absolute" :has-sider="sidebar.enabled">
    <NLayoutSider
      v-if="sidebar.enabled"
      v-model:collapsed="sidebar.collapsed"
      :width="sidebar.width"
      collapse-mode="width"
      :collapsed-width="sidebar.widthCollapsed"
      :show-trigger="sidebar.triggerVisible"
    >
      <NLayout position="absolute">
        <NLayoutHeader ref="sidebarHeaderRef" class="flex items-center justify-between gap-4 shadow sm:hidden">
          <NuxtLink to="/" class="p-4">
            {{ appConfig.title }}
          </NuxtLink>
          <NButton size="large" text @click="sidebar.collapsed = true">
            <div class="p-2">
              <i class="i-carbon-close-large text-2xl"></i>
            </div>
          </NButton>
        </NLayoutHeader>
        <NLayout
          position="absolute"
          :native-scrollbar="false"
          :style="{ top: `${sidebarContentTop + shadowOffset}px` }"
        >
          <NMenu
            :value="menu.current"
            :options="menu.options"
            :collapsed="sidebar.collapsed"
            :collapsed-width="sidebar.widthCollapsed"
            :collapsed-icon-size="menu.iconSize"
            :accordion="menu.accordion"
            @update:value="handleMenuClick"
          />
        </NLayout>
      </NLayout>
    </NLayoutSider>
    <NLayout>
      <NLayoutHeader
        ref="contentHeaderRef"
        class="flex items-center justify-between gap-4 shadow sm:hidden"
      >
        <NuxtLink to="/" class="p-4">
          {{ appConfig.title }}
        </NuxtLink>
        <NButton size="large" text @click="sidebar.collapsed = false">
          <div class="p-2">
            <i class="i-carbon-menu text-2xl"></i>
          </div>
        </NButton>
      </NLayoutHeader>
      <NLayout position="absolute" :native-scrollbar="false" :style="{ top: `${contentTop + shadowOffset}px` }">
        <NLayoutContent>
          <slot></slot>
        </NLayoutContent>
      </NLayout>
    </NLayout>
  </NLayout>
</template>
